feat: Improved installation (#453)

This commit is contained in:
Kroese 2024-05-04 13:28:12 +02:00 committed by GitHub
parent 63c6fc0808
commit 0616eb3447
No known key found for this signature in database
GPG Key ID: B5690EEEBB952194
10 changed files with 955 additions and 613 deletions

View File

@ -21,5 +21,5 @@ jobs:
uses: hadolint/hadolint-action@v3.1.0 uses: hadolint/hadolint-action@v3.1.0
with: with:
dockerfile: Dockerfile dockerfile: Dockerfile
ignore: DL3008,DL4006,SC3037 ignore: DL3008
failure-threshold: warning failure-threshold: warning

View File

@ -1,5 +1,5 @@
FROM scratch FROM scratch
COPY --from=qemux/qemu-docker:4.27 / / COPY --from=qemux/qemu-docker:5.00 / /
ARG DEBCONF_NOWARNINGS "yes" ARG DEBCONF_NOWARNINGS "yes"
ARG DEBIAN_FRONTEND "noninteractive" ARG DEBIAN_FRONTEND "noninteractive"
@ -12,14 +12,11 @@ RUN apt-get update && \
7zip \ 7zip \
wsdd \ wsdd \
samba \ samba \
wimtools \
dos2unix \ dos2unix \
cabextract \ cabextract \
genisoimage \ genisoimage \
libxml2-utils && \ libxml2-utils && \
echo "deb http://deb.debian.org/debian/ sid main" >> /etc/apt/sources.list.d/sid.list && \
echo -e "Package: *\nPin: release n=trixie\nPin-Priority: 900\nPackage: *\nPin: release n=sid\nPin-Priority: 400" | tee /etc/apt/preferences.d/preferences > /dev/null && \
apt-get update && \
apt-get -t sid --no-install-recommends -y install wimtools && \
apt-get clean && \ apt-get clean && \
rm -rf /var/lib/apt/lists/* /tmp/* /var/tmp/* rm -rf /var/lib/apt/lists/* /tmp/* /var/tmp/*

View File

@ -52,8 +52,8 @@
<OSImage> <OSImage>
<InstallFrom> <InstallFrom>
<MetaData wcm:action="add"> <MetaData wcm:action="add">
<Value>1</Value> <Value>Windows 7 PROFESSIONAL</Value>
<Key>/IMAGE/INDEX</Key> <Key>/IMAGE/NAME</Key>
</MetaData> </MetaData>
</InstallFrom> </InstallFrom>
<InstallTo> <InstallTo>
@ -76,7 +76,7 @@
<FullName>Docker</FullName> <FullName>Docker</FullName>
<Organization>Windows for Docker</Organization> <Organization>Windows for Docker</Organization>
<ProductKey> <ProductKey>
<Key>H7X92-3VPBB-Q799D-Y6JJ3-86WC6</Key> <Key>HYF8J-CVRMY-CM74G-RPHKF-PW487</Key>
<WillShowUI>OnError</WillShowUI> <WillShowUI>OnError</WillShowUI>
</ProductKey> </ProductKey>
</UserData> </UserData>

View File

@ -51,7 +51,7 @@
<OSImage> <OSImage>
<InstallFrom> <InstallFrom>
<MetaData wcm:action="add"> <MetaData wcm:action="add">
<Value>Windows Vista Ultimate</Value> <Value>Windows Vista BUSINESS</Value>
<Key>/IMAGE/NAME</Key> <Key>/IMAGE/NAME</Key>
</MetaData> </MetaData>
</InstallFrom> </InstallFrom>
@ -68,7 +68,7 @@
<FullName>Docker</FullName> <FullName>Docker</FullName>
<Organization>Windows for Docker</Organization> <Organization>Windows for Docker</Organization>
<ProductKey> <ProductKey>
<Key>VMCB9-FDRV6-6CDQM-RV23K-RP8F7</Key> <Key>4D2XH-PRBMM-8Q22B-K8BM3-MRW4W</Key>
</ProductKey> </ProductKey>
</UserData> </UserData>
</component> </component>
@ -100,7 +100,7 @@
</component> </component>
<component name="Microsoft-Windows-Shell-Setup" processorArchitecture="amd64" publicKeyToken="31bf3856ad364e35" language="neutral" versionScope="nonSxS"> <component name="Microsoft-Windows-Shell-Setup" processorArchitecture="amd64" publicKeyToken="31bf3856ad364e35" language="neutral" versionScope="nonSxS">
<ComputerName>*</ComputerName> <ComputerName>*</ComputerName>
<ProductKey>VMCB9-FDRV6-6CDQM-RV23K-RP8F7</ProductKey> <ProductKey>4D2XH-PRBMM-8Q22B-K8BM3-MRW4W</ProductKey>
<TimeZone>Pacific Standard Time</TimeZone> <TimeZone>Pacific Standard Time</TimeZone>
<OEMInformation> <OEMInformation>
<Manufacturer>Dockur</Manufacturer> <Manufacturer>Dockur</Manufacturer>

117
readme.md
View File

@ -88,7 +88,7 @@ docker run -it --rm --name windows -p 8006:8006 --device=/dev/kvm --cap-add NET_
| `win81` | Windows 8.1 Pro | 4.2 GB | | `win81` | Windows 8.1 Pro | 4.2 GB |
| `win81e` | Windows 8.1 Enterprise | 3.8 GB | | `win81e` | Windows 8.1 Enterprise | 3.8 GB |
| `win7` | Windows 7 Enterprise | 3.0 GB | | `win7` | Windows 7 Enterprise | 3.0 GB |
| `vista` | Windows Vista Ultimate | 3.6 GB | | `vista` | Windows Vista Enterprise | 3.0 GB |
| `winxp` | Windows XP Professional | 0.6 GB | | `winxp` | Windows XP Professional | 0.6 GB |
|||| ||||
| `2022` | Windows Server 2022 | 4.7 GB | | `2022` | Windows Server 2022 | 4.7 GB |
@ -103,37 +103,6 @@ docker run -it --rm --name windows -p 8006:8006 --device=/dev/kvm --cap-add NET_
To install ARM64 versions of Windows use [dockur/windows-arm](https://github.com/dockur/windows-arm/). To install ARM64 versions of Windows use [dockur/windows-arm](https://github.com/dockur/windows-arm/).
* ### How do I connect using RDP?
The web-viewer is mainly meant to be used during installation, as its picture quality is low, and it has no audio or clipboard for example.
So for a better experience you can connect using any Microsoft Remote Desktop client to the IP of the container, using the username `docker` and by leaving the password empty.
There is a good RDP client for [Android](https://play.google.com/store/apps/details?id=com.microsoft.rdc.androidx) available from the Play Store and one for [iOS](https://apps.apple.com/nl/app/microsoft-remote-desktop/id714464092?l=en-GB) in the Apple Store. For Linux you can use [FreeRDP](https://www.freerdp.com/) and on Windows just type `mstsc` in the search box.
* ### How do I increase the amount of CPU or RAM?
By default, 2 CPU cores and 4 GB of RAM are allocated to the container, as those are the minimum requirements of Windows 11.
To increase this, add the following environment variables:
```yaml
environment:
RAM_SIZE: "8G"
CPU_CORES: "4"
```
* ### How do I change the size of the disk?
To expand the default size of 64 GB, add the `DISK_SIZE` setting to your compose file and set it to your preferred capacity:
```yaml
environment:
DISK_SIZE: "256G"
```
This can also be used to resize the existing disk to a larger capacity without any data loss.
* ### How do I change the storage location? * ### How do I change the storage location?
To change the storage location, include the following bind mount in your compose file: To change the storage location, include the following bind mount in your compose file:
@ -145,40 +114,53 @@ docker run -it --rm --name windows -p 8006:8006 --device=/dev/kvm --cap-add NET_
Replace the example path `/var/win` with the desired storage folder. Replace the example path `/var/win` with the desired storage folder.
* ### How do I change the size of the disk?
To expand the default size of 64 GB, add the `DISK_SIZE` setting to your compose file and set it to your preferred capacity:
```yaml
environment:
DISK_SIZE: "256G"
```
This can also be used to resize the existing disk to a larger capacity without any data loss.
* ### How do I share files with the host? * ### How do I share files with the host?
Open File Explorer and click on the Network section, you will see a computer called `host.lan`, double-click it and it will show a folder called `Data`. Open 'File Explorer' and click on the 'Network' section, you will see a computer called `host.lan`, double-click it and it will show a folder called `Data`.
Inside this folder you can access any files that are placed in `/storage/shared` (see above) on the host. Inside this folder you can access any files that are placed in `/storage/shared` (see above) on the host. You can optionally map it to a drive letter, for easy access.
* ### How do I install a custom image? * ### How do I install a custom image?
In order to download a custom ISO image, start a fresh container with the URL of the ISO specified in the `VERSION` environment variable: In order to download any ISO image that is not part of the list above, start a fresh container with the URL of that ISO specified in the `VERSION` environment variable, for example:
```yaml ```yaml
environment: environment:
VERSION: "https://example.com/win.iso" VERSION: "https://example.com/win.iso"
``` ```
Alternatively, you can also use a local file directly, and skip the download, by binding it in your compose file in this way: Alternatively, you can also use a local file directly, and skip the download altogether, by binding it in your compose file in this way:
```yaml ```yaml
volumes: volumes:
- /home/user/example.iso:/storage/custom.iso - /home/user/example.iso:/storage/custom.iso
``` ```
Replace the example path `/home/user/example.iso` with the filename of the desired ISO file. The value of `VERSION` will be ignored in this case. Replace the example path `/home/user/example.iso` with the filename of your desired ISO file. The value of `VERSION` will be ignored in this case.
* ### How do I customize the installation? * ### How do I customize the installation?
You can customize every setting used by the automatic installation. Download the XML file corresponding to your Windows version, for example [win11x64.xml](https://raw.githubusercontent.com/dockur/windows/master/assets/win11x64.xml). Then apply your modifications to it, and add this line to your compose file: If you want to modify the settings used during the automatic installation, you can do this by editing the answer file corresponding to your Windows edition, for example [win11x64.xml](https://raw.githubusercontent.com/dockur/windows/master/assets/win11x64.xml) in the case of Windows 11 Pro.
Apply your modifications to it, and add this line to your compose file:
```yaml ```yaml
volumes: volumes:
- /home/user/custom.xml:/run/assets/win11x64.xml - /home/user/example.xml:/storage/custom.xml
``` ```
Replace the example path `/home/user/custom.xml` with the filename of the modified XML file. Replace the example path `/home/user/example.xml` with the filename of the modified XML file.
* ### How do I run a script after installation? * ### How do I run a script after installation?
@ -189,7 +171,7 @@ docker run -it --rm --name windows -p 8006:8006 --device=/dev/kvm --cap-add NET_
- /home/user/example:/storage/oem - /home/user/example:/storage/oem
``` ```
The example path `/home/user/example` will be copied to `C:\OEM` during installation and the containing `install.bat` will be executed. The example folder `/home/user/example` will be copied to `C:\OEM` during installation and the containing `install.bat` will be executed during the last step.
* ### How do I perform a manual installation? * ### How do I perform a manual installation?
@ -219,6 +201,37 @@ docker run -it --rm --name windows -p 8006:8006 --device=/dev/kvm --cap-add NET_
- Once you see the desktop, open File Explorer and navigate to the CD-ROM drive (E:). Double-click on `virtio-win-gt-x64.msi` and proceed to install the VirtIO drivers. - Once you see the desktop, open File Explorer and navigate to the CD-ROM drive (E:). Double-click on `virtio-win-gt-x64.msi` and proceed to install the VirtIO drivers.
Enjoy your brand new machine, and don't forget to star this repo! Enjoy your brand new machine, and don't forget to star this repo!
* ### How do I verify if my system supports KVM?
To verify if your system supports KVM, run the following commands:
```bash
sudo apt install cpu-checker
sudo kvm-ok
```
If you receive an error from `kvm-ok` indicating that KVM acceleration can't be used, check the virtualization settings in the BIOS.
* ### How do I increase the amount of CPU or RAM?
By default, 2 CPU cores and 4 GB of RAM are allocated to the container, as those are the minimum requirements of Windows 11.
If there arises a need to increase this, add the following environment variables:
```yaml
environment:
RAM_SIZE: "8G"
CPU_CORES: "4"
```
* ### How do I connect using RDP?
The web-viewer is mainly meant to be used during installation, as its picture quality is low, and it has no audio or clipboard for example.
So for a better experience you can connect using any Microsoft Remote Desktop client to the IP of the container, using the username `docker` and by leaving the password empty.
There is a good RDP client for [Android](https://play.google.com/store/apps/details?id=com.microsoft.rdc.androidx) available from the Play Store and one for [iOS](https://apps.apple.com/nl/app/microsoft-remote-desktop/id714464092?l=en-GB) in the Apple Store. For Linux you can use [FreeRDP](https://www.freerdp.com/) and on Windows just type `mstsc` in the search box.
* ### How do I assign an individual IP address to the container? * ### How do I assign an individual IP address to the container?
@ -272,21 +285,18 @@ docker run -it --rm --name windows -p 8006:8006 --device=/dev/kvm --cap-add NET_
``` ```
Please note that in this mode, the container and Windows will each have their own separate IPs. The container will keep the macvlan IP, and Windows will use the DHCP IP. Please note that in this mode, the container and Windows will each have their own separate IPs. The container will keep the macvlan IP, and Windows will use the DHCP IP.
* ### How do I pass-through a disk? * ### How do I pass-through a disk?
It is possible to pass-through disk devices directly by adding them to your compose file in this way: It is possible to pass-through disk devices directly by adding them to your compose file in this way:
```yaml ```yaml
environment:
DEVICE: "/dev/sda"
DEVICE2: "/dev/sdb"
devices: devices:
- /dev/sda - /dev/sdb:/dev/disk1
- /dev/sdb - /dev/sdc:/dev/disk2
``` ```
Use `DEVICE` if you want it to become your main drive, and use `DEVICE2` and higher to add them as secondary drives. Use `/dev/disk1` if you want it to become your main drive, and use `/dev/disk2` and higher to add them as secondary drives.
* ### How do I pass-through a USB device? * ### How do I pass-through a USB device?
@ -298,17 +308,6 @@ docker run -it --rm --name windows -p 8006:8006 --device=/dev/kvm --cap-add NET_
devices: devices:
- /dev/bus/usb - /dev/bus/usb
``` ```
* ### How do I verify if my system supports KVM?
To verify if your system supports KVM, run the following commands:
```bash
sudo apt install cpu-checker
sudo kvm-ok
```
If you receive an error from `kvm-ok` indicating that KVM acceleration can't be used, check the virtualization settings in the BIOS.
* ### Is this project legal? * ### Is this project legal?

File diff suppressed because it is too large Load Diff

View File

@ -1,7 +1,6 @@
#!/usr/bin/env bash #!/usr/bin/env bash
set -Eeuo pipefail set -Eeuo pipefail
ESD_URL=""
TMP="$STORAGE/tmp" TMP="$STORAGE/tmp"
DIR="$TMP/unpack" DIR="$TMP/unpack"
FB="falling back to manual installation!" FB="falling back to manual installation!"
@ -28,6 +27,78 @@ skipInstall() {
return 1 return 1
} }
startInstall() {
html "Starting Windows..."
[ -z "$MANUAL" ] && MANUAL="N"
if [ -f "$STORAGE/$CUSTOM" ]; then
BASE="$CUSTOM"
else
CUSTOM=""
if [[ "${VERSION,,}" != "http"* ]]; then
BASE="$VERSION.iso"
else
BASE=$(basename "${VERSION%%\?*}")
: "${BASE//+/ }"; printf -v BASE '%b' "${_//%/\\x}"
BASE=$(echo "$BASE" | sed -e 's/[^A-Za-z0-9._-]/_/g')
fi
fi
if [[ "${PLATFORM,,}" == "x64" ]]; then
! migrateFiles "$BASE" "$VERSION" && error "Migration failed!" && exit 57
fi
if skipInstall; then
if [ ! -f "$STORAGE/$BASE" ]; then
BASE="custom.iso"
[ ! -f "$STORAGE/$BASE" ] && BASE=""
fi
[[ "${PLATFORM,,}" == "arm64" ]] && VGA="virtio-gpu"
return 1
fi
if [ -f "$STORAGE/$BASE" ]; then
# Check if the ISO was already processed by our script
local magic=""
magic=$(dd if="$STORAGE/$BASE" seek=0 bs=1 count=1 status=none | tr -d '\000')
magic="$(printf '%s' "$magic" | od -A n -t x1 -v | tr -d ' \n')"
if [[ "$magic" == "16" ]]; then
if hasDisk || [[ "$MANUAL" == [Yy1]* ]]; then
return 1
fi
fi
CUSTOM="$BASE"
fi
rm -rf "$TMP"
mkdir -p "$TMP"
if [ ! -f "$STORAGE/$CUSTOM" ]; then
CUSTOM=""
ISO="$TMP/$BASE"
else
ISO="$STORAGE/$CUSTOM"
fi
return 0
}
finishInstall() { finishInstall() {
local iso="$1" local iso="$1"
@ -44,12 +115,12 @@ finishInstall() {
fi fi
fi fi
rm -f "$STORAGE/windows.ver"
rm -f "$STORAGE/windows.old" rm -f "$STORAGE/windows.old"
rm -f "$STORAGE/windows.boot" rm -f "$STORAGE/windows.boot"
rm -f "$STORAGE/windows.mode" rm -f "$STORAGE/windows.mode"
cp /run/version "$STORAGE/windows.ver" cp /run/version "$STORAGE/windows.ver"
echo "$BASE" > "$STORAGE/windows.base"
if [[ "${PLATFORM,,}" == "x64" ]]; then if [[ "${PLATFORM,,}" == "x64" ]]; then
if [[ "${BOOT_MODE,,}" == "windows_legacy" ]]; then if [[ "${BOOT_MODE,,}" == "windows_legacy" ]]; then
@ -87,92 +158,32 @@ abortInstall() {
return 1 return 1
} }
startInstall() {
html "Starting Windows..."
[ -z "$MANUAL" ] && MANUAL="N"
if [ -f "$STORAGE/$CUSTOM" ]; then
EXTERNAL="Y"
BASE="$CUSTOM"
else
CUSTOM=""
if [[ "${VERSION,,}" != "http"* ]]; then
EXTERNAL="N"
BASE="$VERSION.iso"
else
EXTERNAL="Y"
BASE=$(basename "${VERSION%%\?*}")
: "${BASE//+/ }"; printf -v BASE '%b' "${_//%/\\x}"
BASE=$(echo "$BASE" | sed -e 's/[^A-Za-z0-9._-]/_/g')
fi
fi
if [[ "${PLATFORM,,}" == "x64" ]]; then
! migrateFiles "$BASE" "$VERSION" && error "Migration failed!" && exit 57
fi
if skipInstall; then
[ ! -f "$STORAGE/$BASE" ] && BASE=""
[[ "${PLATFORM,,}" == "arm64" ]] && VGA="virtio-gpu"
return 1
fi
if [ -f "$STORAGE/$BASE" ]; then
# Check if the ISO was already processed by our script
local magic=""
magic=$(dd if="$STORAGE/$BASE" seek=0 bs=1 count=1 status=none | tr -d '\000')
magic="$(printf '%s' "$magic" | od -A n -t x1 -v | tr -d ' \n')"
if [[ "$magic" == "16" ]]; then
if hasDisk || [[ "$MANUAL" == [Yy1]* ]]; then
return 1
fi
fi
EXTERNAL="Y"
CUSTOM="$BASE"
fi
rm -rf "$TMP"
mkdir -p "$TMP"
if [ ! -f "$STORAGE/$CUSTOM" ]; then
CUSTOM=""
ISO="$TMP/$BASE"
else
ISO="$STORAGE/$CUSTOM"
fi
return 0
}
detectCustom() { detectCustom() {
CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname windows.iso -printf "%f\n" | head -n 1) CUSTOM=""
[ -z "$CUSTOM" ] && CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname custom.iso -printf "%f\n" | head -n 1) local file size
[ -z "$CUSTOM" ] && CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname boot.iso -printf "%f\n" | head -n 1)
[ -z "$CUSTOM" ] && CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname custom.img -printf "%f\n" | head -n 1)
if [ -z "$CUSTOM" ] && [[ "${VERSION,,}" != "http"* ]]; then if [[ "${VERSION,,}" != "http"* ]]; then
FN="${VERSION/\/storage\//}" file="${VERSION/\/storage\//}"
[[ "$FN" == "."* ]] && FN="${FN:1}" [[ "$file" == "."* ]] && file="${file:1}"
CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname "$FN" -printf "%f\n" | head -n 1) [[ "$file" == *"/"* ]] && file=""
[ -n "$file" ] && CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname "$file" -printf "%f\n" | head -n 1)
fi fi
[ -z "$CUSTOM" ] && CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname custom.iso -printf "%f\n" | head -n 1)
[ -z "$CUSTOM" ] && CUSTOM=$(find "$STORAGE" -maxdepth 1 -type f -iname custom.img -printf "%f\n" | head -n 1)
[ -z "$CUSTOM" ] && return 0
size="$(stat -c%s "$STORAGE/$CUSTOM")"
if [ -z "$size" ] || [[ "$size" == "0" ]]; then
CUSTOM=""
return 0
fi
file="windows.$size.iso"
[ -s "$STORAGE/$file" ] && CUSTOM="$file"
return 0 return 0
} }
@ -183,15 +194,9 @@ getESD() {
local winCatalog size local winCatalog size
case "${version,,}" in case "${version,,}" in
"win11${PLATFORM,,}") "win11${PLATFORM,,}" ) winCatalog="https://go.microsoft.com/fwlink?linkid=2156292" ;;
winCatalog="https://go.microsoft.com/fwlink?linkid=2156292" "win10${PLATFORM,,}" ) winCatalog="https://go.microsoft.com/fwlink/?LinkId=841361" ;;
;; *) error "Invalid VERSION specified, value \"$version\" is not recognized!" && return 1 ;;
"win10${PLATFORM,,}")
winCatalog="https://go.microsoft.com/fwlink/?LinkId=841361"
;;
*)
error "Invalid VERSION specified, value \"$version\" is not recognized!" && return 1
;;
esac esac
local msg="Downloading product information from Microsoft..." local msg="Downloading product information from Microsoft..."
@ -235,9 +240,9 @@ getESD() {
error "Failed to find Windows product in $eFile!" && return 1 error "Failed to find Windows product in $eFile!" && return 1
fi fi
ESD_URL=$(xmllint --nonet --xpath '//FilePath' "$dir/$eFile" | sed -E -e 's/<[\/]?FilePath>//g') ESD=$(xmllint --nonet --xpath '//FilePath' "$dir/$eFile" | sed -E -e 's/<[\/]?FilePath>//g')
if [ -z "$ESD_URL" ]; then if [ -z "$ESD" ]; then
error "Failed to find ESD URL in $eFile!" && return 1 error "Failed to find ESD URL in $eFile!" && return 1
fi fi
@ -277,12 +282,36 @@ doMido() {
return 1 return 1
} }
verifyFile() {
local iso="$1"
local check="$2"
local hash=""
[ -z "$check" ] && return 0
html "Verifying downloaded ISO..."
info "Calculating SHA256 checksum of the ISO file..."
hash=$(sha256sum "$iso" | cut -f1 -d' ')
if [[ "$hash" == "$check" ]]; then
info "Succesfully verified that the checksum was correct!" && return 0
fi
error "Invalid sha256 checksum: $hash , but expected value is: $check ! Please report this at $SUPPORT/issues"
rm -f "$iso"
return 1
}
downloadFile() { downloadFile() {
local iso="$1" local iso="$1"
local url="$2" local url="$2"
local desc="$3" local sum="$3"
local rc progress domain local desc="$4"
local rc progress domain dots
rm -f "$iso" rm -f "$iso"
@ -296,8 +325,12 @@ downloadFile() {
local msg="Downloading $desc..." local msg="Downloading $desc..."
domain=$(echo "$url" | awk -F/ '{print $3}') domain=$(echo "$url" | awk -F/ '{print $3}')
domain=$(expr "$domain" : '.*\.\(.*\..*\)') dots=$(echo "$domain" | tr -cd '.' | wc -c)
[[ "${domain,,}" != *"microsoft.com" ]] && msg="Downloading $desc from $domain..." (( dots > 1 )) && domain=$(expr "$domain" : '.*\.\(.*\..*\)')
if [ -n "$domain" ] && [[ "${domain,,}" != *"microsoft.com" ]]; then
msg="Downloading $desc from $domain..."
fi
info "$msg" && html "$msg" info "$msg" && html "$msg"
/run/progress.sh "$iso" "Downloading $desc ([P])..." & /run/progress.sh "$iso" "Downloading $desc ([P])..." &
@ -308,13 +341,16 @@ downloadFile() {
if (( rc == 0 )) && [ -f "$iso" ]; then if (( rc == 0 )) && [ -f "$iso" ]; then
if [ "$(stat -c%s "$iso")" -gt 100000000 ]; then if [ "$(stat -c%s "$iso")" -gt 100000000 ]; then
if [[ "$VERIFY" == [Yy1]* ]] && [ -n "$sum" ]; then
! verifyFile "$iso" "$sum" && return 1
fi
html "Download finished successfully..." && return 0 html "Download finished successfully..." && return 0
fi fi
fi fi
rm -f "$iso"
error "Failed to download $url , reason: $rc" error "Failed to download $url , reason: $rc"
rm -f "$iso"
return 1 return 1
} }
@ -323,25 +359,19 @@ downloadImage() {
local iso="$1" local iso="$1"
local version="$2" local version="$2"
local tried="n" local tried="n"
local url desc local url sum desc
if [[ "${version,,}" == "http"* ]]; then if [[ "${version,,}" == "http"* ]]; then
desc=$(fromFile "$BASE")
desc=$(getName "$BASE" "$BASE") downloadFile "$iso" "$version" "" "$desc" && return 0
downloadFile "$iso" "$version" "$desc" && return 0
return 1 return 1
fi fi
if ! validVersion "$version"; then if ! validVersion "$version"; then
error "Invalid VERSION specified, value \"$version\" is not recognized!" && return 1 error "Invalid VERSION specified, value \"$version\" is not recognized!" && return 1
fi fi
if [[ "${PLATFORM,,}" == "x64" ]]; then desc=$(printVersion "$version" "")
desc=$(printVersion "$version" "Windows")
else
desc=$(printVersion "$version" "Windows for ${PLATFORM}")
fi
if [[ "${PLATFORM,,}" == "x64" ]]; then if [[ "${PLATFORM,,}" == "x64" ]]; then
if isMido "$version"; then if isMido "$version"; then
@ -361,37 +391,26 @@ downloadImage() {
if getESD "$TMP/esd" "$version"; then if getESD "$TMP/esd" "$version"; then
ISO="$TMP/$version.esd" ISO="$TMP/$version.esd"
downloadFile "$ISO" "$ESD_URL" "$desc" && return 0 downloadFile "$ISO" "$ESD" "" "$desc" && return 0
ISO="$TMP/$BASE" ISO="$TMP/$BASE"
fi fi
fi fi
url=$(getLink "$version") for ((i=1;i<=MIRRORS;i++)); do
if [ -n "$url" ]; then url=$(getLink "$i" "$version")
if [[ "$tried" != "n" ]]; then if [ -n "$url" ]; then
info "Failed to download $desc from Microsoft, will try another mirror now..." if [[ "$tried" != "n" ]]; then
info "Failed to download $desc, will try another mirror now..."
fi
tried="y"
sum=$(getHash "$i" "$version")
downloadFile "$iso" "$url" "$sum" "$desc" && return 0
fi fi
tried="y" done
downloadFile "$iso" "$url" "$desc" && return 0
fi
url=$(secondLink "$version")
if [ -n "$url" ]; then
if [[ "$tried" != "n" ]]; then
info "Failed to download $desc, will try another mirror now..."
fi
tried="y"
downloadFile "$iso" "$url" "$desc" && return 0
fi
return 1 return 1
} }
@ -450,21 +469,21 @@ extractESD() {
error "Adding Windows Setup failed" && return ${retVal} error "Adding Windows Setup failed" && return ${retVal}
} }
if [[ "${PLATFORM,,}" == "x64" ]]; then
LABEL="CCCOMA_X64FRE_EN-US_DV9"
else
LABEL="CPBA_A64FRE_EN-US_DV9"
fi
local msg="Extracting $desc image..." local msg="Extracting $desc image..."
info "$msg" && html "$msg" info "$msg" && html "$msg"
local edition imageIndex imageEdition local edition imageIndex imageEdition
case "${version,,}" in case "${version,,}" in
"win11${PLATFORM,,}") "win11${PLATFORM,,}" ) edition="11 pro" ;;
edition="11 pro" "win10${PLATFORM,,}" ) edition="10 pro" ;;
;; *) error "Invalid VERSION specified, value \"$version\" is not recognized!" && return 1 ;;
"win10${PLATFORM,,}")
edition="10 pro"
;;
*)
error "Invalid VERSION specified, value \"$version\" is not recognized!" && return 1
;;
esac esac
for (( imageIndex=4; imageIndex<=esdImageCount; imageIndex++ )); do for (( imageIndex=4; imageIndex<=esdImageCount; imageIndex++ )); do
@ -485,11 +504,14 @@ extractImage() {
local iso="$1" local iso="$1"
local dir="$2" local dir="$2"
local version="$3" local version="$3"
local desc="downloaded ISO" local desc="local ISO"
local size size_gb space space_gb local size size_gb space space_gb
if [[ "$EXTERNAL" != [Yy1]* ]] && [ -z "$CUSTOM" ]; then if [ -z "$CUSTOM" ]; then
desc=$(printVersion "$version" "downloaded ISO") desc="downloaded ISO"
if [[ "$version" != "http"* ]]; then
desc=$(printVersion "$version" "$desc")
fi
fi fi
if [[ "${iso,,}" == *".esd" ]]; then if [[ "${iso,,}" == *".esd" ]]; then
@ -498,7 +520,6 @@ extractImage() {
fi fi
local msg="Extracting $desc image..." local msg="Extracting $desc image..."
[ -n "$CUSTOM" ] && msg="Extracting local ISO image..."
info "$msg" && html "$msg" info "$msg" && html "$msg"
rm -rf "$dir" rm -rf "$dir"
@ -523,56 +544,119 @@ extractImage() {
error "Failed to extract ISO file: $iso" && return 1 error "Failed to extract ISO file: $iso" && return 1
fi fi
LABEL=$(isoinfo -d -i "$iso" | sed -n 's/Volume id: //p')
return 0
}
setXML() {
[[ "$MANUAL" == [Yy1]* ]] && return 0
local file="$STORAGE/custom.xml"
[ -f "$file" ] && [ -s "$file" ] && XML="$file" && return 0
file="/run/assets/custom.xml"
[ -f "$file" ] && [ -s "$file" ] && XML="$file" && return 0
file="$1"
[ -z "$file" ] && file="/run/assets/$DETECTED.xml"
[ -f "$file" ] && [ -s "$file" ] && XML="$file" && return 0
return 1
}
selectVersion() {
local tag="$1"
local xml="$2"
local id find name prefer
name=$(sed -n "/$tag/{s/.*<$tag>\(.*\)<\/$tag>.*/\1/;p}" <<< "$xml")
[[ "$name" == *"Operating System"* ]] && name=""
[ -z "$name" ] && return 0
id=$(fromName "$name")
[ -z "$id" ] && warn "Unknown ${tag,,}: '$name'" && return 0
prefer="$id-enterprise"
[ -f "/run/assets/$prefer.xml" ] && find=$(printEdition "$prefer" "") || find=""
if [ -n "$find" ] && [[ "${xml,,}" == *"<${tag,,}>${find,,}</${tag,,}>"* ]]; then
echo "$prefer" && return 0
fi
prefer="$id-ultimate"
[ -f "/run/assets/$prefer.xml" ] && find=$(printEdition "$prefer" "") || find=""
if [ -n "$find" ] && [[ "${xml,,}" == *"<${tag,,}>${find,,}</${tag,,}>"* ]]; then
echo "$prefer" && return 0
fi
prefer="$id"
[ -f "/run/assets/$prefer.xml" ] && find=$(printEdition "$prefer" "") || find=""
if [ -n "$find" ] && [[ "${xml,,}" == *"<${tag,,}>${find,,}</${tag,,}>"* ]]; then
echo "$prefer" && return 0
fi
prefer=$(getVersion "$name")
echo "$prefer"
return 0
}
detectVersion() {
local xml="$1"
local id=""
id=$(selectVersion "DISPLAYNAME" "$xml")
[ -n "$id" ] && [[ "${id,,}" != *"unknown"* ]] && echo "$id" && return 0
id=$(selectVersion "PRODUCTNAME" "$xml")
[ -n "$id" ] && [[ "${id,,}" != *"unknown"* ]] && echo "$id" && return 0
id=$(selectVersion "NAME" "$xml")
[ -n "$id" ] && [[ "${id,,}" != *"unknown"* ]] && echo "$id" && return 0
return 0 return 0
} }
detectImage() { detectImage() {
XML=""
local dsc
local dir="$1" local dir="$1"
local version="$2"
local desc msg
XML=""
if [ -n "$CUSTOM" ]; then if [ -n "$CUSTOM" ]; then
DETECTED="" DETECTED=""
else else
if [ -z "$DETECTED" ] && [[ "$EXTERNAL" != [Yy1]* ]]; then if [ -z "$DETECTED" ] && [[ "${version,,}" != "http"* ]]; then
DETECTED="$VERSION" DETECTED="$version"
fi fi
fi fi
if [ -n "$DETECTED" ]; then if [ -n "$DETECTED" ]; then
if [ -f "/run/assets/$DETECTED.xml" ]; then [[ "${DETECTED,,}" == "winxp"* ]] && return 0
[[ "$MANUAL" != [Yy1]* ]] && XML="$DETECTED.xml"
return 0
fi
if [[ "${DETECTED,,}" != "winxp"* ]]; then setXML "" && return 0
dsc=$(printVersion "$DETECTED" "$DETECTED")
warn "got $dsc, but no matching file called $DETECTED.xml exists, $FB."
fi
desc=$(printEdition "$DETECTED" "this version")
warn "the answer file for $desc was not found ($DETECTED.xml), $FB."
return 0 return 0
fi fi
info "Detecting Windows version from ISO image..." info "Detecting version from ISO image..."
if [[ "${PLATFORM,,}" == "x64" ]]; then if [ -f "$dir/WIN51" ] || [ -f "$dir/SETUPXP.HTM" ]; then
if [ -f "$dir/WIN51" ] || [ -f "$dir/SETUPXP.HTM" ]; then [ -d "$dir/AMD64" ] && DETECTED="winxpx64" || DETECTED="winxpx86"
if [ -d "$dir/AMD64" ]; then desc=$(printEdition "$DETECTED" "Windows XP")
DETECTED="winxpx64" info "Detected: $desc"
else return 0
DETECTED="winxpx86"
fi
dsc=$(printVersion "$DETECTED" "$DETECTED")
info "Detected: $dsc"
return 0
fi
fi fi
local src loc tag result name name2 desc local src loc info
src=$(find "$dir" -maxdepth 1 -type d -iname sources | head -n 1) src=$(find "$dir" -maxdepth 1 -type d -iname sources | head -n 1)
if [ ! -d "$src" ]; then if [ ! -d "$src" ]; then
@ -588,33 +672,26 @@ detectImage() {
warn "failed to locate 'install.wim' or 'install.esd' in ISO image, $FB" && return 1 warn "failed to locate 'install.wim' or 'install.esd' in ISO image, $FB" && return 1
fi fi
tag="DISPLAYNAME" info=$(wimlib-imagex info -xml "$loc" | tr -d '\000')
result=$(wimlib-imagex info -xml "$loc" | tr -d '\000') DETECTED=$(detectVersion "$info")
name=$(sed -n "/$tag/{s/.*<$tag>\(.*\)<\/$tag>.*/\1/;p}" <<< "$result")
DETECTED=$(getVersion "$name")
if [ -z "$DETECTED" ]; then if [ -z "$DETECTED" ]; then
msg="Failed to determine Windows version from image"
tag="PRODUCTNAME" setXML "" && info "${msg}!" && return 0
name2=$(sed -n "/$tag/{s/.*<$tag>\(.*\)<\/$tag>.*/\1/;p}" <<< "$result") warn "${msg}, $FB" && return 0
[ -z "$name" ] && name="$name2"
DETECTED=$(getVersion "$name2")
fi fi
if [ -z "$DETECTED" ]; then desc=$(printEdition "$DETECTED" "$DETECTED")
warn "failed to determine Windows version from string '$name', $FB" && return 0
fi
desc=$(printVersion "$DETECTED" "$DETECTED") info "Detected: $desc"
setXML "" && return 0
if [ -f "/run/assets/$DETECTED.xml" ]; then msg="the answer file for $desc was not found ($DETECTED.xml)"
[[ "$MANUAL" != [Yy1]* ]] && XML="$DETECTED.xml" local fallback="/run/assets/${DETECTED%%-*}.xml"
info "Detected: $desc"
else
warn "detected $desc, but no matching file called $DETECTED.xml exists, $FB."
fi
setXML "$fallback" && warn "${msg}." && return 0
warn "${msg}, $FB."
return 0 return 0
} }
@ -622,45 +699,41 @@ prepareImage() {
local iso="$1" local iso="$1"
local dir="$2" local dir="$2"
local missing
case "${DETECTED,,}" in
"winxp"* )
BOOT_MODE="windows_legacy"
prepareXP "$iso" "$dir" && return 0
error "Failed to prepare Windows XP ISO!" && return 1
;;
"winvista"* | "win7"* | "win2008"* )
BOOT_MODE="windows_legacy" ;;
esac
if [[ "${BOOT_MODE,,}" != "windows_legacy" ]]; then if [[ "${BOOT_MODE,,}" != "windows_legacy" ]]; then
if [[ "${DETECTED,,}" != "winxp"* ]] && [[ "${DETECTED,,}" != "win2008"* ]]; then
if [[ "${DETECTED,,}" != "winvista"* ]] && [[ "${DETECTED,,}" != "win7"* ]]; then
if [ -f "$dir/$ETFS" ] && [ -f "$dir/$EFISYS" ]; then [ -f "$dir/$ETFS" ] && [ -f "$dir/$EFISYS" ] && return 0
return 0
fi
if [ ! -f "$dir/$ETFS" ]; then missing=$(basename "$dir/$EFISYS")
warn "failed to locate file 'etfsboot.com' in ISO image, falling back to legacy boot!" [ ! -f "$dir/$ETFS" ] && missing=$(basename "$dir/$ETFS")
else warn "failed to locate file '${missing,,}' in ISO image!"
warn "failed to locate file 'efisys_noprompt.bin' in ISO image, falling back to legacy boot!"
fi
fi [[ "${PLATFORM,,}" == "arm64" ]] && return 1
fi BOOT_MODE="windows_legacy"
fi fi
[[ "${PLATFORM,,}" == "arm64" ]] && return 1 prepareLegacy "$iso" "$dir" && return 0
if [[ "${DETECTED,,}" == "winxp"* ]]; then error "Failed to extract boot image from ISO!"
if ! prepareXP "$iso" "$dir"; then return 1
error "Failed to prepare Windows XP ISO!" && return 1
fi
else
if ! prepareLegacy "$iso" "$dir"; then
error "Failed to prepare Windows ISO!" && return 1
fi
fi
return 0
} }
updateImage() { updateImage() {
local iso="$1" local iso="$1"
local dir="$2" local dir="$2"
local asset="/run/assets/$3" local asset="$3"
local path src loc xml index result local path src loc xml index result
[ ! -s "$asset" ] || [ ! -f "$asset" ] && return 0 [ ! -s "$asset" ] || [ ! -f "$asset" ] && return 0
@ -694,17 +767,20 @@ updateImage() {
fi fi
if ! wimlib-imagex update "$loc" "$index" --command "add $asset /autounattend.xml" > /dev/null; then if ! wimlib-imagex update "$loc" "$index" --command "add $asset /autounattend.xml" > /dev/null; then
warn "failed to add $xml to ISO image, $FB" && return 1 warn "failed to add answer file ($xml) to ISO image, $FB" && return 1
fi fi
return 0 return 0
} }
copyOEM() { copyOEM() {
local dir="$1" local dir="$1"
local folder="$STORAGE/oem" local folder="/oem"
local src local src
[ ! -d "$folder" ] && folder="/OEM"
[ ! -d "$folder" ] && folder="$STORAGE/OEM"
[ ! -d "$folder" ] && folder="$STORAGE/OEM" [ ! -d "$folder" ] && folder="$STORAGE/OEM"
[ ! -d "$folder" ] && folder="$STORAGE/shared/oem" [ ! -d "$folder" ] && folder="$STORAGE/shared/oem"
[ ! -d "$folder" ] && folder="$STORAGE/shared/OEM" [ ! -d "$folder" ] && folder="$STORAGE/shared/OEM"
@ -734,12 +810,10 @@ buildImage() {
local dir="$1" local dir="$1"
local failed="N" local failed="N"
local cat="BOOT.CAT" local cat="BOOT.CAT"
local label="${BASE%.*}"
local log="/run/shm/iso.log" local log="/run/shm/iso.log"
local size size_gb space space_gb desc local size size_gb space space_gb desc
local out="$TMP/${BASE%.*}.tmp"
label="${label::30}"
local out="$TMP/$label.tmp"
rm -f "$out" rm -f "$out"
desc=$(printVersion "$DETECTED" "ISO") desc=$(printVersion "$DETECTED" "ISO")
@ -756,9 +830,11 @@ buildImage() {
error "Not enough free space in $STORAGE, have $space_gb GB available but need at least $size_gb GB." && return 1 error "Not enough free space in $STORAGE, have $space_gb GB available but need at least $size_gb GB." && return 1
fi fi
[ -z "$LABEL" ] && LABEL="Windows"
if [[ "${BOOT_MODE,,}" != "windows_legacy" ]]; then if [[ "${BOOT_MODE,,}" != "windows_legacy" ]]; then
if ! genisoimage -o "$out" -b "$ETFS" -no-emul-boot -c "$cat" -iso-level 4 -J -l -D -N -joliet-long -relaxed-filenames -V "$label" \ if ! genisoimage -o "$out" -b "$ETFS" -no-emul-boot -c "$cat" -iso-level 4 -J -l -D -N -joliet-long -relaxed-filenames -V "${LABEL::30}" \
-udf -boot-info-table -eltorito-alt-boot -eltorito-boot "$EFISYS" -no-emul-boot -allow-limited-size -quiet "$dir" 2> "$log"; then -udf -boot-info-table -eltorito-alt-boot -eltorito-boot "$EFISYS" -no-emul-boot -allow-limited-size -quiet "$dir" 2> "$log"; then
failed="Y" failed="Y"
fi fi
@ -767,7 +843,7 @@ buildImage() {
if [[ "${DETECTED,,}" != "winxp"* ]]; then if [[ "${DETECTED,,}" != "winxp"* ]]; then
if ! genisoimage -o "$out" -b "$ETFS" -no-emul-boot -c "$cat" -iso-level 2 -J -l -D -N -joliet-long -relaxed-filenames -V "$label" \ if ! genisoimage -o "$out" -b "$ETFS" -no-emul-boot -c "$cat" -iso-level 2 -J -l -D -N -joliet-long -relaxed-filenames -V "${LABEL::30}" \
-udf -allow-limited-size -quiet "$dir" 2> "$log"; then -udf -allow-limited-size -quiet "$dir" 2> "$log"; then
failed="Y" failed="Y"
fi fi
@ -775,7 +851,7 @@ buildImage() {
else else
if ! genisoimage -o "$out" -b "$ETFS" -no-emul-boot -boot-load-seg 1984 -boot-load-size 4 -c "$cat" -iso-level 2 -J -l -D -N -joliet-long \ if ! genisoimage -o "$out" -b "$ETFS" -no-emul-boot -boot-load-seg 1984 -boot-load-size 4 -c "$cat" -iso-level 2 -J -l -D -N -joliet-long \
-relaxed-filenames -V "$label" -quiet "$dir" 2> "$log"; then -relaxed-filenames -V "${LABEL::30}" -quiet "$dir" 2> "$log"; then
failed="Y" failed="Y"
fi fi
@ -872,7 +948,7 @@ if ! extractImage "$ISO" "$DIR" "$VERSION"; then
exit 62 exit 62
fi fi
if ! detectImage "$DIR"; then if ! detectImage "$DIR" "$VERSION"; then
abortInstall "$ISO" && return 0 abortInstall "$ISO" && return 0
exit 60 exit 60
fi fi
@ -888,7 +964,8 @@ if ! updateImage "$ISO" "$DIR" "$XML"; then
fi fi
if ! rm -f "$ISO" 2> /dev/null; then if ! rm -f "$ISO" 2> /dev/null; then
BASE="windows.iso" size="$(stat -c%s "$ISO")"
BASE="windows.$size.iso"
ISO="$STORAGE/$BASE" ISO="$STORAGE/$BASE"
rm -f "$ISO" rm -f "$ISO"
fi fi

View File

@ -388,7 +388,7 @@ consumer_download() {
# Filter for 64-bit ISO download URL # Filter for 64-bit ISO download URL
# sed: HTML decode "&" character # sed: HTML decode "&" character
# tr: Filter for only alphanumerics or punctuation # tr: Filter for only alphanumerics or punctuation
iso_download_link="$(echo "$iso_download_link_html" | grep -o "https://software.download.prss.microsoft.com.*IsoX64" | cut -d '"' -f 1 | sed 's/&amp;/\&/g' | tr -cd '[:alnum:][:punct:]' | head -c 512)" iso_download_link="$(echo "$iso_download_link_html" | grep -o "https://software.download.prss.microsoft.com.*IsoX64" | cut -d '"' -f 1 | sed 's/&amp;/\&/g' | tr -cd '[:alnum:][:punct:]')"
if ! [ "$iso_download_link" ]; then if ! [ "$iso_download_link" ]; then
# This should only happen if there's been some change to the download endpoint web address # This should only happen if there's been some change to the download endpoint web address

View File

@ -28,7 +28,7 @@ boot() {
[ -f "$QEMU_END" ] && return 0 [ -f "$QEMU_END" ] && return 0
if [ -s "$QEMU_PTY" ]; then if [ -s "$QEMU_PTY" ]; then
if grep -iq " hard" "$QEMU_PTY"; then if [ "$(stat -c%s "$QEMU_PTY")" -gt 7 ]; then
info "Windows started succesfully, visit http://localhost:8006/ to view the screen..." info "Windows started succesfully, visit http://localhost:8006/ to view the screen..."
return 0 return 0
fi fi
@ -93,7 +93,9 @@ finish() {
pid="/var/run/tpm.pid" pid="/var/run/tpm.pid"
[ -s "$pid" ] && pKill "$(<"$pid")" [ -s "$pid" ] && pKill "$(<"$pid")"
fKill "wsdd" pid="/var/run/wsdd.pid"
[ -s "$pid" ] && pKill "$(<"$pid")"
fKill "smbd" fKill "smbd"
closeNetwork closeNetwork

View File

@ -82,6 +82,7 @@ if [[ "$isXP" == [Yy1]* ]]; then
else else
# Enable Web Service Discovery # Enable Web Service Discovery
wsdd -i "$interface" -p -n "$hostname" & wsdd -i "$interface" -p -n "$hostname" &
echo "$!" > /var/run/wsdd.pid
fi fi
return 0 return 0